
setGeneric(name = "compute_degrees", def = function(source, attribute, mf) {
  standardGeneric("compute_degrees")
})

setMethod(f = "compute_degrees", signature = c("data.frame"), definition = function(source, attribute, mf) {
  degrees <- as.data.frame(sapply(source[[attribute]], function(x) mf$degree(x)))
  colnames(degrees) <- paste(attribute, "degree", sep = "_")
  return(degrees)
})

setMethod(f = "compute_degrees", signature = c("SpatialPointsDataFrame"), definition = function(source, attribute, mf) {
  degrees <- compute_degrees(source@data, attribute, mf)
  return(SpatialPointsDataFrame(source@coords, degrees, proj4string = rebuild_CRS(source@proj4string), match.ID = FALSE))
})

setMethod(f = "compute_degrees", signature = c("SpatialMultiPointsDataFrame"), definition = function(source, attribute, mf) {
  degrees <- compute_degrees(source@data, attribute, mf)
  return(SpatialMultiPointsDataFrame(source@coords, degrees, proj4string = rebuild_CRS(source@proj4string), match.ID = FALSE))
})

setMethod(f = "compute_degrees", signature = c("SpatialPolygonsDataFrame"), definition = function(source, attribute, mf) {
  Sr <- SpatialPolygons(source@polygons, proj4string = rebuild_CRS(source@proj4string))
  degrees <- compute_degrees(source@data, attribute, mf)
  return(SpatialPolygonsDataFrame(Sr, degrees, match.ID = FALSE))
})
