
perform_interpolation <- function(data_frame, attribute_name, border, interrow_distance, swath_width) {
  block_size <- swath_width * interrow_distance * 4
  block <- c(block_size, block_size)
  model <- c("Sph", "Exp")
  fit_options <- list(merge.small.bins = TRUE, min.np.bin = 150, boundaries = c(1:20) * interrow_distance)
  fix_values <- c(TRUE, NA, NA)
  auto_interpolation(data_frame, border, interrow_distance, attribute_name, model = model, block = block, miscFitOptions = fit_options, fix.values = fix_values)
}

write_interpolation_summary <- function(interpolation, summary_file) {
  pdf(file = summary_file)
  plot(interpolation)
  dev.off()
}

get_interpolation_raster <- function(interpolation) {
  raster <- brick(interpolation$krige_output)
  NAvalue(raster) <- NaN
  return(raster)
}

write_interpolation_raster <- function(interpolation, raster_file) {
  raster <- get_interpolation_raster(interpolation)
  writeRaster(raster, raster_file, format = "GTiff", NAflag = NaN, overwrite = TRUE)
}
