
installPackagesWithDependencies <- function(packages, db = available.packages(), ...) {
    stopifnot(require(tools))
    dependencies <- package_dependencies(packages, db = db);
    install.packages(c(packages, do.call(c, unname(dependencies))), ...)
}

updatePackagesWithDependencies <- function(packages, db = available.packages(), lib.loc, repos) {
    stopifnot(require(tools))
    dependencies <- do.call(c, unname(package_dependencies(packages, db = db)));
    updatables <- unname(old.packages(lib.loc = lib.loc, repos = repos)[,"Package"])
    installables <- intersect(updatables, c(packages, dependencies))
    if(length(installables) > 0) 
        install.packages(installables, lib = lib.loc, repos = repos)
}
