
InputHistogram <- R6Class("InputHistogram",
  private = list(
    .input_histogram = NULL,
    .degree_histogram = NULL
  ),

  active = list(
    breaks = function(breaks) {
      private$.input_histogram$breaks <- breaks
      private$.degree_histogram$breaks <- breaks
    },

    input_histogram = function() {
      return(private$.input_histogram$histogram)
    },

    degree_histogram = function() {
      return(private$.degree_histogram$histogram)
    }
  ),

  public = list(
    initialize = function(source, attribute, mf) {
      private$.input_histogram <- Histogram$new(source, attribute)
      degree_process <- degree_process$new(source, attribute, mf)
      degree_process$compute_degrees()
      degrees <- degree_process$degrees
      degree_attribute <- paste(attribute, "degree", sep = "_")
      private$.degree_histogram <- Histogram$new(degrees, degree_attribute)
    },

    perform = function() {
      private$.input_histogram$perform()
      private$.degree_histogram$perform()
    }
  )
)
