
canopy_cleanup_process <- R6Class("canopy_cleanup_process",
  inherit = cleanup_process,

  private = list(
    .plot_process = NULL,
    .canopy_process = NULL
  ),

  public = list(
    initialize = function(output_path, plot_process, canopy_process) {
      super$initialize(output_path, "canopy")
      private$.plot_process <- plot_process
      private$.canopy_process <- canopy_process
    },

    cleanup = function() {
      cleanup_function <- function() perform_canopy_cleanup(
          private$.canopy_process$canopy_data_frame,
          private$.plot_process$name,
          private$.plot_process$row_orientation,
          private$.canopy_process$sensor_offset,
          private$.canopy_process$speed_range,
          private$.canopy_process$ndvi_range,
          private$.summary_file
        )
      super$cleanup(cleanup_function)
    }
  )
)
