
canopy_interpolation_process <- R6Class("canopy_interpolation_process",
  inherit = interpolation_process,

  private = list(
    .plot_process = NULL,
    .canopy_process = NULL,
    .cleanup_process = NULL
  ),

  public = list(
    initialize = function(output_path, plot_process, canopy_process, cleanup_process) {
      super$initialize(output_path, "canopy")
      private$.plot_process <- plot_process
      private$.canopy_process <- canopy_process
      private$.cleanup_process <- cleanup_process
    },

    interpolate = function() {
      interpolation_function <- function() perform_interpolation(
          private$.cleanup_process$trimmed_data_frame,
          "NDVI",
          private$.plot_process$border,
          private$.plot_process$interrow_distance,
          private$.canopy_process$swath_width
        )
      super$interpolate(interpolation_function)
    }
  )
)
