
yield_cleanup_process <- R6Class("yield_cleanup_process",
  inherit = cleanup_process,

  private = list(
    .plot_process = NULL,
    .yield_process = NULL
  ),

  public = list(
    initialize = function(output_path, plot_process, yield_process) {
      super$initialize(output_path, "yield")
      private$.plot_process <- plot_process
      private$.yield_process <- yield_process
    },

    cleanup = function() {
      cleanup_function <- function() perform_yield_cleanup(
          private$.yield_process$yield_data_frame,
          private$.yield_process$sensor_type,
          private$.plot_process$name,
          private$.yield_process$trim,
          private$.yield_process$delay,
          private$.summary_file
        )
      super$cleanup(cleanup_function)
    }
  )
)
