
yield_interpolation_process <- R6Class("yield_interpolation_process",
  inherit = interpolation_process,

  private = list(
    .plot_process = NULL,
    .yield_process = NULL,
    .cleanup_process = NULL
  ),

  public = list(
    initialize = function(output_path, plot_process, yield_process, cleanup_process) {
      super$initialize(output_path, "yield")
      private$.plot_process <- plot_process
      private$.yield_process <- yield_process
      private$.cleanup_process <- cleanup_process
    },

    interpolate = function() {
      interpolation_function <- function() perform_interpolation(
          private$.cleanup_process$trimmed_data_frame,
          "Yield",
          private$.plot_process$border,
          private$.plot_process$interrow_distance,
          private$.yield_process$swath_width
        )
      super$interpolate(interpolation_function)
    }
  )
)
