
Histogram <- R6Class("Histogram",
  cloneable = FALSE,

  private = list(
    .source = NULL,
    .attribute = NULL,
    .breaks = NULL,
    .histogram = NULL,

    .release = function() {
      private$.breaks <- "Sturges"
      private$.histogram <- NULL
    }
  ),

  active = list(
    breaks = function(breaks) {
      if (missing(breaks)) {
        return(private$.breaks)
      } else {
        private$.release()
        private$.breaks <- breaks
      }
    },

    attribute = function(attribute) {
      if (missing(attribute)) {
        return(private$.attribute)
      } else {
        private$.release()
        private$.attribute <- attribute
      }
    },

    histogram = function() {
      return(private$.histogram)
    }
  ),

  public = list(
    initialize = function(source, attribute) {
      private$.source <- source
      private$.attribute <- attribute
      private$.breaks <- "Sturges"
    },

    perform = function() {
      values <- private$.source@data[, private$.attribute]
      private$.histogram <- hist(values, plot = FALSE, breaks = private$.breaks)
    }
  )
)
