
Kriging <- setRefClass("Kriging", 
    contains = "InterpolationMethod",    
    
    fields = c(fitting = "OptionalFitting", 
    	nMin = "numeric", 
    	nMax = "numeric",
    	maxDistance = "numeric"),

    methods = list(
        computeInterpolation = function(data, locations, grid) {
            krige(data~1, locations, grid, model = computeVariogramModel(fitting), maxdist = maxDistance, nmin = nMin, nmax = nMax)
        },
        
        equals = function(other) {
            (nMin == other$nMin) & (nMax == other$nMax) & (maxDistance == other$maxDistance) & identical(fitting, other$fitting)
        }
    )
)
