calcul_TOi=function(x_mat,y_mat,z_mat,nbr,nbc,kernel,threshold,cellsize,disp) {

  #Transformation des donnees regulieres en matrice
  matrice=(matrix(z_mat[order(x_mat,-y_mat)],nrow=nbr,ncol=nbc,byrow=FALSE))
  
  #Transformation de cette matrice en une matrice binaire : 
  bin_mat=binaryMatrix(matrice,threshold)  
  #display(t(bin_mat))
  
  #Filtre (opening-closing):
  filtered_mat=filtre(bin_mat,kernel,threshold,cellsize)
  
  
  #Vérification de la matrice : filtered_mat doit toujours avoir quelques 1 ou 0 pour eviter les divisions par 0 par la suite
  #if (sum(na.omit(filtered_mat)) < 0.01*length(na.omit(filtered_mat))) {
  if (sum(filtered_mat==1, na.rm = TRUE) < 0.01 * sum(!is.na(filtered_mat))) {
    #seuil trop haut : moins de 5% des sites sont attribues a la strategie B
    #return(c(0,0,0,0,0,0)) 
  }

  #else if (sum(na.omit(filtered_mat)) > 0.99*length(na.omit(filtered_mat))) {
  else if (sum(filtered_mat==0, na.rm = TRUE) < 0.01 * sum(!is.na(filtered_mat))) {
    #seuil trop bas : moins de 5% des sites sont attribues a la strategie A
    #return(c(0,0,0,0,0,0))
  }
    
  #Comptage du nombre de sites correctement manages pour chacune des strategies
  prob = calculProb(bin_mat,filtered_mat)
  summary(prob)
  TOi=(2^2)*(prob[[1]]*prob[[2]]*(1-prob[[3]]))
  
  if(disp==TRUE) {
    display(t(matrice))
    display(t(bin_mat))
    display(t(filtered_mat))
    display(t(prob[[4]]))
  }
  
  return(list(TOi,threshold,prob[[3]],prob[[1]],prob[[2]],prob[[4]],filtered_mat))
}