main_calcul_TOi_pol = function (x_mat, y_mat, z_mat, nbr, nbc, machine, percentage, threshold, cellsize, disp) {
  #x_mat=grid_datas[[3]]
  #y_mat=grid_datas[[4]]
  #z_mat=grid_datas[[5]]
  #nbr=grid_datas[[1]]
  #nbc=grid_datas[[2]]
  
  #Definition de l'empreinte spatiale
  kernel=footprintMachine(machine) #Largeur,longeur,surface
  
  #Si on a une empreinte spatiale trop petite comparee a la taille des cellules de l'interpolation, 
  # Il y aura trop peu de mesures (1 en general) par empreinte spatiale donc pas d'erreur possible selon la methode
  if (2*cellsize>kernel[1] | 2*cellsize>kernel[2]) {
    return(NULL)
  }
  
  #On centre et reduit la variable z_mat (variable z regularisee sur l'ensemble de la parcelle)
  z_mat=scale(z_mat,center=TRUE,scale=TRUE)
  #Si le seuil est NULL, on cherche le seuil majorant l'indice par la fonction alphaOpt :
  if (is.null(threshold)==TRUE) {
    threshold=alphaOpt(x_mat,y_mat,z_mat,nbr,nbc,kernel,percentage,cellsize)
  }
  #Sinon, le seuil est donne, on le centre et le reduit
  else {
    threshold=(threshold-attr(z_mat,"scaled:center"))/(attr(z_mat,"scaled:scale"))
  }
  #Appel a la fonction calcul_TOi
  TOi=calcul_TOi(x_mat,y_mat,z_mat,nbr,nbc,kernel,threshold,cellsize,disp)
  TOi[[2]]=as.numeric(TOi[[2]])*attr(z_mat,"scaled:scale")+(attr(z_mat,"scaled:center")) #On "decentre" et "dereduit" le seuil
  error=c()
  strategy=c()
  polygons_list=list()
  count=1
  for(i in seq(1,nbr)) {
    for(j in seq(1,nbc)) {
      if (is.na(z_mat[(i-1)*nbc+j])==FALSE) {
        #Coordonnees du polygone correspondant a la mesure 
        coord=cbind(c(x_mat[(i-1)*nbc+j]-cellsize/2,x_mat[(i-1)*nbc+j]+cellsize/2,x_mat[(i-1)*nbc+j]+cellsize/2,x_mat[(i-1)*nbc+j]-cellsize/2,x_mat[(i-1)*nbc+j]-cellsize/2),
                    c(y_mat[(i-1)*nbc+j]-cellsize/2,y_mat[(i-1)*nbc+j]-cellsize/2,y_mat[(i-1)*nbc+j]+cellsize/2,y_mat[(i-1)*nbc+j]+cellsize/2,y_mat[(i-1)*nbc+j]-cellsize/2))
        #Transformation en Polygons (liste de 1 Polygon) et stockage dans polygons_list
        polygons_list[[count]]=Polygons(list(Polygon(coord)),count)
        
        error[count]=(TOi[[6]])[nbr-i+1,j] #On va chercher l'erreur correspondante au site
        strategy[count]=(TOi[[7]])[nbr-i+1,j] #Et la strategie associee
        count=count+1
      }
    }
  }
  #Renvoie d'un SpatialPolygonsDataFrame contenant polygons_list,error et strategy
  TOi[[6]]=SpatialPolygonsDataFrame(Sr=SpatialPolygons(polygons_list),data=data.frame(error,strategy))
  TOi[[7]]=NULL
  
  return(TOi)
}





