
identical_wkt <- function(lhs, rhs) {
  identical(showWKT(lhs), showWKT(rhs))
}

identical_epsg <- function(lhs, rhs) {
  lhs_epsg <- showEPSG(lhs)
  rhs_epsg <- showEPSG(rhs)
  !identical(lhs_epsg, "OGRERR_UNSUPPORTED_SRS") && !identical(rhs_epsg, "OGRERR_UNSUPPORTED_SRS") && identical(lhs_epsg, rhs_epsg)
}

setGeneric("identical_coordinate_system", function(lhs, rhs) {
  standardGeneric("identical_coordinate_system")
})

setMethod("identical_coordinate_system", signature(lhs = "character", rhs = "character"), function(lhs, rhs) {
  (lhs == rhs) || identical_wkt(lhs, rhs) || identical_epsg(lhs, rhs)
})

setMethod("identical_coordinate_system", signature(lhs = "Spatial", rhs = "character"), function(lhs, rhs) {
  identical_coordinate_system(proj4string(lhs), rhs)
})

setMethod("identical_coordinate_system", signature(lhs = "character", rhs = "Spatial"), function(lhs, rhs) {
  identical_coordinate_system(lhs, proj4string(rhs))
})

setMethod("identical_coordinate_system", signature(lhs = "Spatial", rhs = "Spatial"), function(lhs, rhs) {
  identical_coordinate_system(proj4string(lhs), proj4string(rhs))
})

setMethod("identical_coordinate_system", signature(lhs = "Raster", rhs = "Spatial"), function(lhs, rhs) {
  identical_coordinate_system(proj4string(lhs), proj4string(rhs))
})

setMethod("identical_coordinate_system", signature(lhs = "Spatial", rhs = "Raster"), function(lhs, rhs) {
  identical_coordinate_system(proj4string(lhs), proj4string(rhs))
})

setMethod("identical_coordinate_system", signature(lhs = "Raster", rhs = "Raster"), function(lhs, rhs) {
  identical_coordinate_system(proj4string(lhs), proj4string(rhs))
})
