

get_epsg_crs <- function(coordinate) {
  if (!is.numeric(coordinate)) stop("coordinate must be numeric")
  if (length(coordinate) != 2) stop("coordinate must be 2D")
  longitude <- coordinate[1]
  latitude <- coordinate[2]
  zone <- get_utm_zone(longitude, latitude)
  epsg_format <- ifelse(latitude > 0, "326%02d", "327%02d")
  epsg <- sprintf(epsg_format, zone)
  CRS(paste0("+init=epsg:", epsg))
}
