
get_grid_topology <- function(border, cellsize) {
  bbox <- bbox(border)
  xmin <- bbox["x", "min"]
  dx <- bbox["x", "max"] - xmin
  ymin <- bbox["y", "min"]
  dy <- bbox["y", "max"] - ymin
  xdim <- ceiling(dx / cellsize)
  ydim <- ceiling(dy / cellsize)
  GridTopology(cellcentre.offset = c(xmin, ymin), cellsize = c(cellsize, cellsize), cells.dim = c(xdim, ydim))
}

increase_grid_topology <- function(grid_topology, cells) {
  cellcentre.offset <- grid_topology@cellcentre.offset
  cellsize <- grid_topology@cellsize
  cells.dim <- grid_topology@cells.dim
  xmin <- cellcentre.offset[1] - (cells * cellsize[1])
  ymin <- cellcentre.offset[2] - (cells * cellsize[2])
  xdim <- cells.dim[1] + (2 * cells)
  ydim <- cells.dim[2] + (2 * cells)
  GridTopology(c(xmin, ymin), cellsize, c(xdim, ydim))
}
