
#' Explode coordinates to Multipoint coords numeric matrix, based on the size of Multipoints.
#'
#' @param x_coords numeric vector, x coordinates of all points to explode to multipoint coords.
#' @param y_coords numeric vector, y coordinates of all points to explode to multipoint coords.
#'
#' @return a list of numeric matrix, the coords of all Multipoints.
#'
#' @export
#' @keywords internal
#'
explode_multipoints_coords <- function(x_coords, y_coords) {
  coord_index <- 1 # the coordinate index

  #' Main function to build Multipoint coords.
  #'
  #' @param multipoint_size integer, the size of the Multipoint.
  #'
  #' @return a numeric matrix, the coords of the Multipoint.
  #'
  function(multipoint_size) {
    coord_end <- coord_index + multipoint_size - 1
    x <- x_coords[coord_index:coord_end]
    y <- y_coords[coord_index:coord_end]
    coord_index <<- coord_end + 1
    cbind(x, y)
  }
}
