geofis_fitting = function(model, nugget, a1, sill, varioexp, iter = TRUE) {

	m = vgm(psill = sill, model, range = a1, nugget = nugget)
	
	fi = fit.variogram(varioexp, m, fit.sills = FALSE, fit.ranges = FALSE)
	#iter = !attr(fi, "singular")
	rmse = sqrt(attr(fi, "SSErr"))
	
	#nugget = fi[1, "psill"]
	#sill = fi[2, "psill"]
	#a1 = fi[2, "range"]
	
	vl = variogramLine(m, maxdist = varioexp[nrow(varioexp), 2], n = 200)
	return(list(nugget, a1, sill, iter, rmse, vl))
}