
geofis_variogram_cloud = function(x, y, data, boundaries) {

	df = data.frame(x, y, data)
	coordinates(df) = ~x + y

	vario2 = variogram(data~1, df, cutoff = max(boundaries), cloud = TRUE)
	vario3 = cbind(vario2[,2], vario2[,3]) #dist et gamma

	# ajouter np, et quantiles
	ma = order(vario3[,1])
	vario4dist = vario3[ma, 1]
	vario4gamma = vario3[ma, 2]
	boundaries = c(0, boundaries)
	vcut = cut(vario4dist, boundaries)
	#vars = tapply(vario4gamma, vcut, var)
	meand = tapply(vario4dist, vcut, mean)
	meangamma = tapply(vario4gamma, vcut, mean)
	quant = tapply(vario4gamma, vcut, quantile, probs = c(0.25, 0.75))
	inf = vector("numeric", length(boundaries) - 1)
	sup = inf
	np = inf
	np = table(vcut)
	for ( i in 1:length(inf)) {
		if(is.null(quant[i][[1]][1])) {
			inf[i] =  sup[i] = NA
		} else {
			inf[i] = quant[i][[1]][1]
			sup[i] = quant[i][[1]][2]
		}
	}
	#for ( i in 1:length(inf)) {
	#	inf[i] = max(0, meangamma[i] - sqrt(vars[i]))
	#	sup[i] = meangamma[i] + sqrt(vars[i])
	#}
	
	return(list(np[np>0], meand[!is.na(meand)], meangamma[!is.na(meangamma)], inf[!is.na(inf)], sup[!is.na(sup)]))
}
